# PhasicFlow: src/phasicFlow/types/quadruple/quadrupleMath.hpp File Reference
PhasicFlow is an open-source parallel DEM (discrete element method) package for simulating granular flow. It is developed in C++ and can be exectued on both GPU (like CUDA) and CPU.

quadrupleMath.hpp File Reference

Go to the source code of this file.

## Macros

#define | Q4Func(fnName)
#define | Q4Func2(fnName)

## Macro Definition Documentation

## Q4Func

#define Q4Func | ( |  | fnName | ) |

Value:
template<typename T> \
inline pFlow::quadruple<T> pFlow::fnName(const quadruple<T>& q) \
{ \
return quadruple<T>(fnName(q.s_), fnName(q.v_)); \
}

Definition at line 21 of file quadrupleMath.hpp.

## Q4Func2

#define Q4Func2 | ( |  | fnName | ) |

Value:
template<typename T> \
inline pFlow::quadruple<T> pFlow::fnName( \
const quadruple<T>& arg1, const quadruple<T>& arg2 \
) \
{ \
return quadruple<T>( \
fnName(arg1.s_, arg2.s_), fnName(arg1.v_, arg2.v_) \
); \
}

Definition at line 28 of file quadrupleMath.hpp.

pFlow::quadruple
Definition: quadruple.hpp:36